<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
  <xsl:output method="xml"/>
  <xsl:template match="/">
    <xsl:if test="DirectorySet/file">
      <DirectorySet>
        <xsl:apply-templates select="DirectorySet/file">
          <!-- Sort on the type of entry first, then on the filename -->
          <xsl:sort select="@ty"/>
          <xsl:sort select="@nm"/>
        </xsl:apply-templates>
      </DirectorySet>
    </xsl:if>
  </xsl:template>

  <xsl:template match="file">
    <xsl:if test="@nm != 'calibration' and @nm != 'include' and @nm != '.svn' and not(contains(@nm, ' copy'))">
      <xsl:variable name="filename" select="substring-before(@nm, '.xml')"/>
      <xsl:choose>
        <xsl:when test="@ty='f'">
          <file fileName="{$filename}" fileType="{@ty}" fileSize="{@sz}"/>
        </xsl:when>
        <xsl:otherwise>
          <file fileName="{@nm}" fileType="{@ty}" fileSize="{@sz}"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
